#!/usr/bin/env node
'use strict'

var fs = require("fs"),
    mime = require("mime"),
    http = require("http"),
    express = require("express"),
    archiver = require('archiver'),
    getSize = require('get-folder-size'),
    minimist = require("minimist"),
    path = require("path"),
    app = express();

var argv = minimist(process.argv.slice(2))
const PORT = 3000;
if (argv._[0] == "folder") {

    var folder = argv._[1];
    if (folder == "this")
        folder = process.cwd();
    if (fs.existsSync(folder)) {
        getSize(folder, function (err, size) {
            app.use("*", (req, res) => {
                StreamFolder(size,folder, req, res);
            });
            StartStream();
        });
    } else {
        console.error("Folder doesnt exist !")
    }
}

if (argv._[0] == "file") {
    var filePath = argv._[1];
    filePath = path.join(process.cwd(), filePath);
    if (fs.existsSync(filePath)) {

        app.use("*", (req, res) => {
            StreamFile(filePath, req, res);
        });
        StartStream();
    }
}

function StreamFolder(size,path, req, res) {
    var archive = archiver.create('zip', {});
    res.set({
        "Content-Type": 'application/zip',
        'Content-disposition': 'attachment; filename=' + path.basename(folder) + ".zip",
        'Content-Length': size,
    })
    archive.pipe(res);
    archive.directory(folder);
    archive.finalize();
}

function StreamFile(filePath, req, res) {
    var name = path.basename(filePath);
    res.set("Content-Disposition", " attachment; filename=" + name)
    res.sendFile(filePath);
}
function StartStream() {
    app.listen(3000, () => {
        console.log(`Start Stream on http://localhost:${PORT}`)
    })
}